/*
* 
* 5648-C83, 5648-C84 (C) COPYRIGHT International Business Machines Corp., 2007 
 * All rights reserved * Licensed Materials - Property of IBM  
 * 
 */
dojo.require("dojo.dnd.Source");

// The FreeformPortlet model object
function FreeformPortlet(page, element) {
	var METHODNAME = "FreeformPortlet.ctor ";
	console && console.log && console.log(METHODNAME + "Entry" );
	Portlet.call(this, page, element);
	
	var w = dijit.byId(element.id);
	if(w) {
		this.portletData = w.portletData;
		this.eventSettings = w.eventSettings;
		this.page.addPortletZIndex(this.element);
		this.resizeHandler = dojo.connect(w, "onResize", this, "resize");
		this.moveHandler = dojo.connect(w, "onMove", this, "onMove");
	}
	else {
		console && console.error && console.error( METHODNAME + ": FreeformPortlet constructed from an element that's not a freeform portlet" );
	}
	if("dynamic" === this.portletData.location) {
		dojo.addClass(this.element, "tip-portlet-dynamic");

		// move it to the bottom
		var portletsInPage = Portlet.getPortletElements(this.page.element);
    	var i, y = 0, l = portletsInPage.length-1, mb,
    		mbthis = dojo.marginBox(this.element);
    	for(i = 0; i < l; ++i) {
    		if( !dojo.hasClass(portletsInPage[i], "isc-portlet-fullscreen") ) {
    			mb = dojo.marginBox(portletsInPage[i]);
    			if(mb.l <= mbthis.w)
    				y = Math.max(y, mb.t + mb.h);
    		}
    	}
    	if(mbthis.t < y) {
    		mbthis.t = y;
    		mbthis.l = 0;
    		dojo.marginBox(this.element, mbthis);
    		dojo.window.scrollIntoView(this.element);
    	}
	}
	else if(-1 == this.portletData.globalPortletSize[2]) {
		// this portlet was created without a location
		// center it
		var content = dojo.query(".tip-freeform-content", this.page.element)[0];
		mb = dojo.contentBox(content);
		mbthis = dojo.marginBox(this.element);
		mbthis.l = content.scrollLeft + (mb.w - mbthis.w) / 2;
		mbthis.t = content.scrollTop + (mb.h - mbthis.h) / 2;
		dojo.marginBox(this.element, mbthis);	
	}
	dojo.addClass(this.element, "tip-mode-" + page.pageData.editMode);
	
	this.checkForApplets();
	
	this.updatePortletForMode();

	//255529
	// Trigger any queued events (especially important for iwidgets, as this function hooks WIDGET_LOADED to triggering any queued events)
	EventBroker.runSendEventToPortlet( element.id, this.page.element.id );

	console && console.log && console.log(METHODNAME + "Exit" );
}
FreeformPortlet.prototype = new Portlet();
FreeformPortlet.prototype.constructor=FreeformPortlet;

FreeformPortlet.prototype.destroy = function()
{
	console && console.log && console.log("FreeformPortlet.prototype.destroy");
	if(this.resizeHandler)
		dojo.disconnect(this.resizeHandler);
	if(this.moveHandler)
		dojo.disconnect(this.moveHandler);
	if(this.menuOpenHandle)
		dojo.disconnect(this.menuOpenHandle);
	Portlet.prototype.destroy.call(this);
	
	if(this.h) {
		dojo.disconnect(h);
	}
}
FreeformPortlet.prototype.onMove = function()
{
	this.savePortletPosition();
	// of the portlet was dragged outside the boundary of the page, the page just grew
	// we have to resize 
	ibm.tivoli.tip.ffcustomizer.fullscreenResizeHandler();
}
FreeformPortlet.prototype.resize = function(bSaveToServer)
{
	if(bSaveToServer) this.savePortletPosition();
	try {
        //forward framework events to iWidgets - rework 245979
        if (iWBridge && ("true" == this.portletData.iwidget))
        {
        	var size= iscPortlet.getPortletSize(this.portletData.namespace);
			if(!size || !size.available.h)
			{			
				var  payload = {newWidth: size.available.w, newHeight: size.available.h};
				iWBridge.frameWork(iWidgetUtils.piiToWidgetId(this.portletData.oid), payload, null, "onSizeChanged", "onSizeChanged" );
			}
        }
        else {
        	EventBroker.sendEventToPortlet(this.portletData.namespace, {name: "http://ibm.com/isclite#portletResize"});
        }
	} 
	catch(e)
	{
		// ignore
	}

}

 
		
FreeformPortlet.prototype.savePortletPosition = function()
{
	if("edit" === this.page.pageData.editMode) {
		this.editPortletPosition();
	}
	else if("personalize") {
		this.personalizePortletPosition();
	}
}
// simply cache the new position/size 
FreeformPortlet.prototype.personalizePortletPosition = function()
{
//	this.portletData.userPortletSize = true;
}
// save portlet position and size to the server
FreeformPortlet.prototype.editPortletPosition = function()
{
	var w = dijit.byId(this.element.id),
		pos = w.get("position"),
		uid = this.page.pageData.tid;

	var uniquePageName = this.page.pageData.uniquePageName;
	if (uniquePageName.indexOf("_") > 0 && uniquePageName.indexOf("banner.isc.welcome") < 0){
		uniquePageName = uniquePageName.substring(0,uniquePageName.indexOf("_"));
	}

	var url = contextRoot + '/customizer.do?action=resize'
						+ '&moduleRef=' + this.page.pageData.moduleRef
						+ '&pageId=' +  uniquePageName
						+ '&windowId=' + this.element.id
						+ '&width1=' + Math.round(pos.w)
						+ '&height1=' + Math.round(pos.h)
						+ '&tip.x=' + Math.round(pos.l)
						+ '&tip.y=' + Math.round(pos.t)
						+ '&tip.z=' + pos.z
	                                        + "&XSS="+top.window.XSS
	if ( uid ) url += '&uid=' + uid;

	dojo.xhrGet( {
		url: encodeURI( url ),
		handleAs: "text",
		sync: false,
		error: function(response) {
			// TODO: what?
			return response;
		}
	} );
	
};
FreeformPortlet.prototype.updatePortletForMode = function()
{
	// there are 9 possible combinations of page mode + portlet mode
	/*
	 * portlet/page
	 * view/view	view/edit		view/personalize
	 * edit/view	edit/edit		edit/personalize
	 * dynamic/view	dynamic/edit	dynamic/personalize
	 */
	var port_map = {view: 0, edit: 1, edit_defaults: 1, dynamic: 2}, page_map = {view: 0, edit: 1, personalize: 2}; 
	var nada = /^nada$/;
	var menuOptions = [
	       // portlet view mode, page[view, edit, personalize]
	       [nada, 
	        new RegExp("personalizeClass|editDefaultsClass|skinMenuClass"
					+ "|fillPageMenuClass"
					+ "|bringToFrontMenuClass|sendToBackMenuClass|bringForwardMenuClass|sendBackwardMenuClass"
					+ "|eventsOptionClass|deleteOptionClass|aboutPortletOptionClass"),
			/personalizeClass|bringToFrontMenuClass|sendToBackMenuClass|bringForwardMenuClass|sendBackwardMenuClass/],
			// portlet edit mode, page[view, edit, personalize]
	        [nada, nada, nada],
	        // portlet dynamic mode, page[view, edit, personalize]
	        [/bringToFrontMenuClass|sendToBackMenuClass|bringForwardMenuClass|sendBackwardMenuClass/,
	         new RegExp("personalizeClass|editDefaultsClass|skinMenuClass"
						+ "|fillPageMenuClass"
						+ "|bringToFrontMenuClass|sendToBackMenuClass|bringForwardMenuClass|sendBackwardMenuClass"
						+ "|eventsOptionClass"),
	         /personalizeClass|bringToFrontMenuClass|sendToBackMenuClass|bringForwardMenuClass|sendBackwardMenuClass/]
	];
	// which buttons?
	var buttonOptions = [
	      [/tip-portlet-help-btn/, /tip-portlet-help-btn/, /tip-portlet-help-btn/],							// view
	      [nada, /tip-portlet-back-btn|tip-portlet-help-btn/, /tip-portlet-back-btn|tip-portlet-help-btn/],		// edit
	      [/tip-portlet-close-btn|tip-portlet-help-btn/, /tip-portlet-close-btn|tip-portlet-help-btn/, /tip-portlet-close-btn|tip-portlet-help-btn/]		// dynamic
	];
	// supports move/resize?
	var moveOptions = [[false, true, true],		// portlet view, page[view, edit, personalize] 
	                   [false, false, false], 	// portlet edit, page[view, edit, personalize]
	                   [true, true, true]];		// portlet dyna, page[view, edit, personalize]
	
	var portlet = dijit.byId(this.element.id),
		port_mode = ("dynamic" === this.portletData.location) ? "dynamic" : this.portletData.mode,
		port_fullscreen = portlet.get("fullscreen"),
		page_mode = this.page.pageData.editMode;
	
	var menu_opt =  menuOptions[port_map[port_mode]] [page_map[page_mode]],
	    btn_opt = buttonOptions[port_map[port_mode]] [page_map[page_mode]],
	    mov_opt = moveOptions[port_map[port_mode]] [page_map[page_mode]];
	
	var dropDownButton = dijit.byId(this.element.id + "_dropDownButton");
	if(dropDownButton) {
		var menu = dropDownButton.dropDown;
		var menuItems = menu.getChildren();
		var displayedItemCount = 0, nChildren = menuItems.length, preSep = 0, postSep = 0, lastSep = null, item, i, d, cls;
		for(i = 0; i < nChildren; ++i) {
			item = menuItems[i];
			cls = item["class"];
			
			// determine what menu items are visible
			if(cls.indexOf("menuSeperatorClass") >= 0) {
				// this is a seperator
				if(lastSep) {
					dojo.style(lastSep.domNode, "display", (preSep && postSep) ? "" : "none");
				}
				preSep = postSep;
				postSep = 0;
				lastSep = item;
			}
			else {
				// this is a menu item
				d = "none";
				if(menu_opt.test(cls)) {
					++postSep;
					++displayedItemCount;
					d = "";
					
					// since this is visible, sync it's check with the portlet
					// sync the state of the checked menu items with the portlet
					if(cls.indexOf("fillPageMenuClass") >= 0) {
						item.set("checked", port_fullscreen);
					}
					else if(/skinMenuClass/.test(cls)) {
						this.syncSkinMenuWithPortlet(item.popup, portlet.get("skin"));
					}

					if(cls.indexOf("eventsOptionClass") >= 0) {
						// only show the events item if there is a storage manager present
						if(!dijit.byId(this.page.pageData.uniquePageName + "_store_id"))
							d = "none"
					}
				}
				dojo.style(item.domNode, "display", d);
			}
		}
		if(lastSep) {
			dojo.style(lastSep.domNode, "display", (preSep && postSep) ? "" : "none");
		}
		
		// if no menuitems were displayed, don't show the dropdown button
		dojo.style(dropDownButton.domNode, "display", (0 == displayedItemCount) ? "none" : "");
	}
	var w = dijit.byId(this.element.id);
	w.set("moveable", mov_opt);
	
	// assign the portlet the proper class based on the page's mode
	this.element.className = this.element.className.replace(/\btip-mode-.+?\b/, "tip-mode-" + page_mode);

	dojo.query(".tip-portlet-toolbar-button", this.element).forEach(function(b) {
		(b !== dropDownButton.domNode) && dojo.style(b, "display", btn_opt.test(b.className) ? "" : "none");
	});
	//Always hide the help button for an iWidget, since its client side it will show or hide itself
	if("true" == this.portletData.iwidget) {
	  iWidgetToolbar.disableButton("help" + this.element.id);
	}
};
FreeformPortlet.prototype.syncSkinMenuWithPortlet = function(skinMenu, portlet_skin)
{
	// skin menu item class is one of 	defaultSkinOptionClass|skinAOptionClass|skinBOptionClass|skinCOptionClass
	if("" === portlet_skin) portlet_skin = "defaultSkin";
	portlet_skin += "OptionClass";
	
	var menuItems = skinMenu.getChildren(),
		i, nChildren = menuItems.length, cls, item;
	for(i = 0; i < nChildren; ++i) {
		item = menuItems[i];
		cls = item["class"];
		item.set("checked", cls.indexOf(portlet_skin) == 0);
	}
};
FreeformPortlet.prototype.checkForApplets = function()
{
	if(dojo.query("applet,object,embed,iframe", this.page.element).length > 0) {
		dojo.query("div.tip-portlet", this.page.element).forEach(function(p) {
			var w = dijit.byId(p.id);
			if(w) {
				w.addShim();
			}
		});
	}
}

// The FreeformPage model object
function FreeformPage(element)
{
	console && console.log && console.log("FreeformPage.ctor");
	// DnD support
	this.connects = [];
	this.dnd_target = null;

	// call the Page constructor
	Page.call(this, element);	
	
	var pd=element.getAttribute("pagedataobject");
	this.pageData = pd ? dojo.fromJson(pd) : null;
	
	this.loadDropZone();
	var that = this;
	dojo.query(".tip-freeform-content", this.element).forEach(function(n) {
		dojo.style(n, "cursor", ("edit" == that.pageData.editMode) ? "" : "default");
	});
};
FreeformPage.prototype = new Page();
FreeformPage.prototype.constructor = FreeformPage;

FreeformPage.prototype.destroy = function()
{
	var c;
	while(c = this.connects.pop()) {
		dojo.disconnect(c);
	}
	this.dnd_target.destroy();
	this.dnd_target = null;
	Page.prototype.destroy.call(this);
};

FreeformPage.prototype.show=function() {
	// I tried calling Page.prototype.show, then updating this.element's left, but it didn't work
	// so I copied the code here.
	dojo.removeClass(this.element, "page-hide");
	dojo.addClass(this.element, "page-show");
	dojo.addClass(this.element, "wire-dnd-target-portlet");

	//Changing position to static causes applets to reset on FF.  Instead set left and right bounds to make sure it's full width.
	dojo.style(this.element, {
			position: "absolute",
			//left: "0px", //delete this line to avoid overriding the left value in .page-hide
			right: "0px"
			// don't specify top or bottom, since .page-hide controls top
	});
	
	iscPortlet.sendResizeEvent('FreeformPage.show');
	this.element.focus();
};

FreeformPage.prototype.getPortletSize = function(namespace)
{
	var portletDiv = dojo.isString( namespace ) ?
			iscPortlet.getPortletByNamespace( namespace ) : 
			customizer.getAncestors( node, function(node) {
					return !!dijit.registry.byId(node.id);
				}, true );

	if(null == portletDiv) {
		// can happen when dojo.addOnLoad calls ns_*_resize before the portlet widget has been parsed
		return {
			current: {w:100, h:100},
			available: {w:100, h:100},
			percents: {w:100, h:100}
		};
	}
	
	var w = dijit.byId(portletDiv.id);
	if(!w) {
		return false;
	}
	
	var avail = w.get("ContentSize");
	
	// There's a <td> inside the content isolation iframe that may have padding we need to account for
	// This calculation is copied from IscPortlet.getPortletSize() in portlet.js 
	var p3 = { t:0, l:0, r:0, b:0 };
	var contentIframes = dojo.query( 'iframe[name$="isc_iframe"]', portletDiv );
	if( contentIframes.length > 0 ) {
		// Get the iFrame's document
		var iframe_doc = contentIframes[0].contentWindow || contentIframes[0].contentDocument;
		if( iframe_doc.document ) iframe_doc = iframe_doc.document;

		var iframeContentTd = dojo.query( 'td.isc-portlet-bkg', iframe_doc.body )[0];
		if( iframeContentTd ) p3 = iscPortlet.getPadding( iframeContentTd );
	}

	avail.h -= p3.t + p3.b; 
	avail.w -= p3.l + p3.r;
	
	var total = dojo.contentBox(portletDiv.modelObject.page.element);

	return {
		current: { w: avail.w, h: avail.h },
		available: { w: avail.w, h: avail.h },
		percents: { w: Math.floor(avail.w/total.w*100+.5), h: Math.floor(avail.h/total.h*100+.5) }
	};
};

FreeformPage.prototype.isFreeformPage = true;
FreeformPage.prototype.makePortletModelObject = function(port) 
{
	var portletObj = null;
	if(port instanceof FreeformPortlet) {
		portletObj = port;
	}
	else {
		if("object" === typeof port.modelObject &&
			"function" === typeof port.modelObject.destroy) 
		{
			port.modelObject.destroy();
		}
		portletObj = port.modelObject = new FreeformPortlet(this, port);
	}
	return portletObj;
};
FreeformPage.prototype.makePageModelObject = function(pg) 
{
	var pageObj = null;
	if(pg instanceof FreeformPage) {
		pageObj = pg;
	}
	else {
		if("object" === typeof pg.modelObject &&
			"funcdtion" === typeof pg.modelObject.destroy)
		{
			pg.modelObject.destroy();
		}
		pageObj = pg.modelObject = new FreeformPage(pg);
	}
	return pageObj;
};
FreeformPage.prototype._addPortletToPage = function(newPortletElement) {
	console && console.log && console.log("FreeformPage.prototype._addPortletTOpAGE");
	var parentPage = null;
	
	// put the new portlet fragment into the page
	var freeformContainer = document.getElementById(newPortletElement.getAttributeNode( "pageid" ).value +"FreeformContent");
	
	// move it out of sight until it's parsed into its dojo widget
	dojo.style(newPortletElement, "visibility", "hidden");
	
	// add to the DOM
	freeformContainer.appendChild(newPortletElement);

	// Create the Portlet object for the new portlet.
	var wlist = dojo.parser.parse(freeformContainer);
	// once parsed, newPortletElement has been replaced in the DOM
	var w = dijit.byId(newPortletElement.id);
	if(w) {
		newPortletElement = w.domNode;
	}
	
	// make it visible
	dojo.style(newPortletElement, "visibility", "");
	
	this.makePortletModelObject( newPortletElement );
	
	// Run any scripts in the new portlet
	SMUtils.RunScripts( newPortletElement );

	// TODO: hoist this up to Page?
	// TODO: remove newPortletPage.createPortlets()?

// I've never seen this called before dojo was loaded
//	var newPortletPage = this;
//	var tempFunc = function() {
	PortletLink.hookAnchors(newPortletElement);  
	PortletLink.hookForms(newPortletElement);
	doFpFetch( newPortletElement );
//	newPortletPage.createPortlets();
//
//	 dojo.addOnLoad( tempFunc );

  //customizer.setupPorltetWiresDragAndDrop(newPortletElement); //253940

	//255909 omit this -- updateSystemWires is already done from the fetchEvents handler. Doing it twice here can introduce faulty system wires.
	/*
  try {
    var iwId = "_iw" + newPortletElement.modelObject.portletData.oid;
    var pageId = newPortletElement.modelObject.page.pageData.uid;
	  var eventService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);
	  eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + iwId, null, function(){
	    iWidgetUtils.updateSystemWires(pageId);
	  }, null, null);
	} catch(a) {
	  console && console.log && console.log("FreeformPage.prototype._addPortletToPage: failed to create wire for added portlet - " + a.message);
	}
	*/
};
//
// Replace a portlet on the page
//   newPortletFragment: a <div> that is the new version of the portlet, unparsed by dojo
//   oldPortletElement: the <div> that is the current portlet in the document. It is a full-blown dijit
FreeformPage.prototype._replacePortletInPage = function(newPortletElement, oldPortletElement)
{
	//DEBUG console.info( "Need to update portlet window " + newPortletElement.id );
	
	var portletPage, portlet = null;
	if(oldPortletElement) {
		// Get the portlet model
		portlet = oldPortletElement.modelObject ? 
				oldPortletElement.modelObject :
				this.makePortletModelObject(oldPortletElement);

		parentPage = portlet.page; //232882
		if( newPortletElement !=null ) {
			
			portlet.replacePortlet( newPortletElement );
			SMUtils.RunScripts( newPortletElement );
		} else {
			// Close any iframe popups this portlet has open
			portlet.clearPopups();

			//DEBUG console.info( "removing the node..." );
			// Remove the IscPortlet div
			oldPortletElement.parentNode.removeChild( oldPortletElement );

			//DEBUG console.info( "Portlet removed" );

			//DEBUG console.info( "Destroying portlet in window: " + portletElement.id );
			//229889 dojo._destroyElement(portletFragment);
			UIElement.destroyElement( oldPortletElement );

		}
		portlet = null;
	}
};

FreeformPage.prototype.setPageInPersonalizeMode = function(bPersonalizeMode)
{
	if(bPersonalizeMode && "view" != this.pageData.editMode) {
		console && console.error && console.error("You can only enter personalize mode from view mode");
		return;
	}
	this.pageData.pageShowingEditMode = false;	// CYA
	
	if(bPersonalizeMode) {
		this.pageData.editMode = "personalize";
		dojo.addClass(this.pageData.uid + "_freeform_personalize_toolbar_container", "show");
	}
	else {
		this.pageData.editMode = "view";
		dojo.removeClass(this.pageData.uid + "_freeform_personalize_toolbar_container", "show");
	}
	ibm.tivoli.tip.ffcustomizer.resize(this.element);
	top.frames.taskbar.fpTaskBarDropDownListDisableOption("Personalize", bPersonalizeMode);
	top.frames.taskbar.fpTaskBarDropDownListDisableOption("EditPage", bPersonalizeMode);
	this.onPageChangeMode();
}
FreeformPage.prototype.setPageShowingEditMode = function(bEditMode) 
{
	this.pageData.pageShowingEditMode = bEditMode;
	this.onPageChangeMode();
};
FreeformPage.prototype.onPageChangeMode = function()
{
	var content = dojo.query(".tip-freeform-content", this.element);
	var arr = Portlet.getPortletElements(this.element);
	var i, l = arr.length, w, portletModel, port_elem;
	for(i = 0; i < l; ++i) {
		port_elem = arr[i];
		w = dijit.byId(port_elem.id);
		if(w) {
			portletModel = port_elem.modelObject;
			if(portletModel) 
				portletModel.updatePortletForMode();
		}	
	}
	if(content.length > 0) {
		dojo.style(content[0], "cursor", ("edit" === this.pageData.editMode) ? "" : "default");
	}
}

// z-Index support
FreeformPage.prototype.addPortletZIndex = function(pdiv)
{
	if(parseInt(dojo.style(pdiv, "zIndex")) > 0) return;// already assigned a z-index
 
	var z = this.findPortletMaxZIndex();
	dojo.style(pdiv, "zIndex", z);
};
FreeformPage.prototype.findPortletMaxZIndex = function()
{
	var arr = Portlet.getPortletElements(this.element);
	var i = 0, l = arr.length, maxz = 0, z;
	for(; i < l; ++i) {
		z = parseInt(dojo.style(arr[i], "zIndex"));
		maxz = z > maxz ? z : maxz;
	} 
	return ++maxz;
};
FreeformPage.prototype.bringPortletForward = function(port_div)
{
	var moved_portlets = {};
	var dynamic = dojo.hasClass(port_div, "tip-portlet-dynamic");
	var arr = Portlet.getPortletElements(this.element);
	if("edit" != this.pageData.editMode) {
		// only shuffle among a portlet's own kind
		arr = dojo.filter(arr, function(p) {
			var d = dojo.hasClass(p, "tip-portlet-dynamic");
			return dynamic ? d : !d;
		});
	}
	// sort bottom to top
	arr.sort(function(a, b) {
		var za = dojo.style(a, "zIndex"),
			zb = dojo.style(b, "zIndex");
		return za - zb;
	});
	var i = 0, l = arr.length, p, q, z;
	for(; i < l; ++i) {
		p = arr[i];
		if(port_div === p) {
			if(++i < l) {	// then there is a portlet above me
				q = arr[i];
				this.swapZ(p, q);
				moved_portlets[p.id] = p;
				moved_portlets[q.id] = q;
				break;
			}
		}
	}
	for(p in moved_portlets) {
		moved_portlets[p].modelObject.savePortletPosition();
	}
};
FreeformPage.prototype.sendPortletBackward = function(port_div)
{
	var moved_portlets = {};
	var dynamic = dojo.hasClass(port_div, "tip-portlet-dynamic");
	var arr = Portlet.getPortletElements(this.element);
	arr = dojo.filter(arr, function(p) {
		var d = dojo.hasClass(p, "tip-portlet-dynamic");
		return dynamic ? d : !d;
	}); 
	// sort top to bottom
	arr.sort(function(a, b) {
		var za = dojo.style(a, "zIndex"),
			zb = dojo.style(b, "zIndex");
		return zb - za;
	});
	var i = 0, l = arr.length, p, q, z;
	for(; i < l; ++i) {
		p = arr[i];
		if(port_div === p) {
			if(++i < l) {	// then there is a portlet below me
				q = arr[i];
				this.swapZ(p, q);
				moved_portlets[p.id] = p;
				moved_portlets[q.id] = q;
				break;
			}
		}
	}
	for(p in moved_portlets) {
		moved_portlets[p].modelObject.savePortletPosition();
	}
};
FreeformPage.prototype.bringPortletToFront = function(port_div)
{
	var moved_portlets = {};
	var dynamic = dojo.hasClass(port_div, "tip-portlet-dynamic");
	var arr = Portlet.getPortletElements(this.element);
	if("edit" != this.pageData.editMode) {
		// only shuffle among a portlet's own kind
		arr = dojo.filter(arr, function(p) {
			var d = dojo.hasClass(p, "tip-portlet-dynamic");
			return dynamic ? d : !d;
		}); 
	}
	// sort bottom to top
	arr.sort(function(a, b) {
		var za = dojo.style(a, "zIndex"),
			zb = dojo.style(b, "zIndex");
		return za - zb;
	});
	var l = arr.length, maxz, i;
	if(l == 1) return;
	if(arr[l-1] === port_div) return;	// portlet is already on top
	for(i = l-2; l >= 0; --i) {
		this.swapZ(arr[i+1], arr[i]);
		moved_portlets[arr[i+1].id] = arr[i+1];
		moved_portlets[arr[i].id] = arr[i];

		if(arr[i] === port_div)
			break;
	}
	for(p in moved_portlets) {
		moved_portlets[p].modelObject.savePortletPosition();
	}
};
FreeformPage.prototype.sendPortletToBack = function(port_div)
{
	var moved_portlets = {};
	var dynamic = dojo.hasClass(port_div, "tip-portlet-dynamic");
	var arr = Portlet.getPortletElements(this.element);
	if("edit" != this.pageData.editMode) {
		// only shuffle among a portlet's own kind
		arr = dojo.filter(arr, function(p) {
			var d = dojo.hasClass(p, "tip-portlet-dynamic");
			return dynamic ? d : !d;
		});
	}
	// sort top to bottom
	arr.sort(function(a, b) {
		var za = dojo.style(a, "zIndex"),
			zb = dojo.style(b, "zIndex");
		return zb - za;
	});
	var l = arr.length, maxz, i;
	if(l == 1) return;
	if(arr[l-1] === port_div) return;	// portlet is already on the bottom
	for(i = l-2; l >= 0; --i) {
		this.swapZ(arr[i+1], arr[i]);
		moved_portlets[arr[i+1].id] = arr[i+1];
		moved_portlets[arr[i].id] = arr[i];
		if(arr[i] === port_div)
			break;
	}
	for(p in moved_portlets) {
		moved_portlets[p].modelObject.savePortletPosition();
	}
};
FreeformPage.prototype.swapZ = function(p, q){
	var z = dojo.style(q, "zIndex");
	dojo.style(q, "zIndex", dojo.style(p, "zIndex"));
	dojo.style(p, "zIndex", z);
};

// DnD
FreeformPage.prototype.loadDropZone = function()
{
	var arr = dojo.query(".tip-freeform-content", this.element),
		pg = arr.length > 0 ? arr[0] : null;

	this.connects.push(dojo.connect(pg, "onmouseup", this, this.getMouseCoords));
	this.dnd_target = new dojo.dnd.Target(pg, {accept: ["widget"]}); 
	this.dnd_target.onDropExternal = dojo.hitch(this, this.onDropWidget);	
};
FreeformPage.prototype.dropX = 0;
FreeformPage.prototype.dropY = 0;
FreeformPage.prototype.getMouseCoords = function (e) {
	var n = e.target;
	this.dropX = e.pageX;
	this.dropY = e.pageY;
	while(!!n && !dojo.hasClass(n, "tip-freeform-content")) {
		n = n.offsetParent;
	}
	if(!!n) {
		this.dropX -= n.offsetLeft;
		this.dropY -= n.offsetTop;
	}
	return;
};
FreeformPage.prototype._createNewWidget = function(widget_descriptor, loc)
{
	var currentPageId = IscPages.currentPageId + "FreeformContent";

	if (this.dnd_target.node.id == currentPageId) {
		var z = this.findPortletMaxZIndex(widget_descriptor.dom);
		var url = contextRoot + '/customizer.do?action=createcontent'
					    + '&moduleRef=' + widget_descriptor.moduleId
						+ '&portletName=' + widget_descriptor.name
					    + '&portletAppId=' + widget_descriptor.portletAppID
						+ '&tip.newContent=' + widget_descriptor.id
						+ "&XSS="+top.window.XSS;
		if(loc) {
			url += "&tip.windowCoordinates=" + loc.x + ";" + loc.y + ";" + z
				+ "&tip.location=specified";
		}
		else {
			url += "&tip.location=unknown";
		}

		url = encodeURI( url );
		dojo.xhrPost( {
			url: url,
			handleAs: "text",
			load: dojo.hitch(this, function( response ) { 
				// make a div from the response
				var tempDiv = IscPages.MakeDivFromPortletFragments( response );

				// create the new portlet(s) in the page
				IscPages.UpdatePortletFragmentsDiv(tempDiv);
				
				// find and run any <script> nodes in the response
				// by now, the portlet <div>s have been removed, so there's no risk 
				// that we'll re-execute script that's part of a portlet or iWidget
				dojo.query("script", tempDiv).forEach(function(script_node) {
					script_node.parentNode.removeChild(script_node);
					if(dojo.isIE) {
						try {
							eval(script_node.innerHTML);
						}
						catch(e) {
							console && console.error && console.error("failed evaling script: " + e.message);
						}
					}
					else {
						dojo.body().appendChild(script_node);
					}
				});
				
				// The last portlet element is the one we just created
				var portletList = Portlet.getPortletElements( this.element );
				var lastPortletElement = portletList[portletList.length-1];
				if(lastPortletElement) {
					EventBroker.runSendEventToPortlet(lastPortletElement.id, IscPages.currentPageId);
					lastPortletElement.focus();
					lastPortletElement.modelObject.resize(true);
				}
				else {
					console && console.error && console.error("Unexpected result: /customizer.do?action=createcontent succeeded, but no portlet was returned");
				}
				FreeformPage.fetchEvents(portletList, widget_descriptor);

				return response;
			}),
			error: function(response) {
				console && console.error && console.error("Error creating a new widget or portlet: " + response);
				return response;
			}
		} );
	}
	
}
FreeformPage.prototype.onDropWidget = function(source, nodes, copy, target)
{
	var jsnode = source.getItem(nodes[0].id);
	var data = jsnode.data;
	this._createNewWidget(data, {x: this.dropX, y: this.dropY});
};
FreeformPage.prototype.h = null;
FreeformPage.prototype.hookEditMode = function(palette)
{
	this.connects.push( dojo.connect(palette, "onShow", this, "_sizePageForPalette") );
	this.connects.push( dojo.connect(palette, "onHide", this, "_sizePageForPalette") );
	this.connects.push( dojo.connect(palette, "onSelectWidget", this, "_createNewWidget") );
	this._sizePageForPalette(palette);
};
FreeformPage.prototype._sizePageForPalette = function(palette)
{
	ibm.tivoli.tip.ffcustomizer.resize(this.element);
	return;
};
FreeformPage.prototype.getPortletBoundingBox = function()
{
    var portletsInPage = Portlet.getPortletElements(this.element);
    
   	var i, x = 0, box = {w: 0, h: 0}, l = portletsInPage.length, mb, port;
   	for(i = 0; i < l; ++i) {
   		port = portletsInPage[i];
   		if( !dojo.hasClass(port, "isc-portlet-fullscreen") ) {
    		mb = dojo.marginBox(portletsInPage[i]);
    		box.w = Math.max(box.w, mb.l + mb.w);
    		box.h = Math.max(box.h, mb.t + mb.h);
    	}
   	}
   	return box;
}
// Personalization support ---------------------
FreeformPage.prototype.personalizeSave = function()
{
	var portletList = Portlet.getPortletElements(this.element),
		i, l = portletList.length, p, counter, pii, box;
	var url = contextRoot + '/ppa.do?action=save&pageid=' + this.getPageUID() +"&XSS="+top.window.XSS;

	for (i = 0, counter=i+1; i < l; ++i, ++counter) {
		p = portletList[i];
		pii = p.modelObject.portletData.basePii;
		box = dojo.marginBox(p);

		url += '&pii' + counter + '=' + pii
				+ 'X' + box.w
				+ 'Y' + box.h
				+ 'Z' + dojo.style(p, "zIndex")
				+ 'LEFT' + box.l  
				+ 'TOP' + box.t;

		p.modelObject.portletData.userPortletSize = [box.w,box.h,box.l,box.t,dojo.style(p,"zIndex")];

	}

	url = encodeURI( url );

	dojo.xhrGet( {
		url: url,
		handleAs: "text",
		load: function(response) { console && console.log && console.log("FreeformPage.personalizeSave success"); return response; },
		error: function(response) { console && console.log && console.log("FreeformPage.personalizeSave success"); return response; }
	} );
}
FreeformPage.prototype.personalizeCancel = function()
{
	var portletList = Portlet.getPortletElements(this.element),
		i, l = portletList.length, p, box, sz;
	for(i = 0; i < l; ++i) {
		p = portletList[i];
			sz = p.modelObject.portletData.userPortletSize ? p.modelObject.portletData.userPortletSize : p.modelObject.portletData.globalPortletSize;
			box = {l: sz[2], t: sz[3], w: sz[0], h: sz[1]};
			dojo.marginBox(p, box);
			dojo.style(p, "zIndex", sz[4]);
			p.modelObject.resize();	// TODO: necessary?
	}
}
FreeformPage.prototype.personalizeRestore = function()
{
	var url = contextRoot + '/ppa.do?action=restore&pageid=' + this.getPageUID() +"&XSS="+top.window.XSS;
	var portletList = Portlet.getPortletElements(this.element),
		i, l = portletList.length, p, counter, pii, sz;
	for(i = 0, counter=1; i < l; ++i, ++counter) {
		p = portletList[i];
		pii = p.modelObject.portletData.basePii;
		if(p.modelObject.portletData.userPortletSize) {
			url += '&pii' + counter + '=' + pii;
		}
		sz = p.modelObject.portletData.globalPortletSize;
		box = {l: sz[2], t: sz[3], w: sz[0], h: sz[1]};
		dojo.marginBox(p, box);
		dojo.style(p, "zIndex", sz[4]);
		p.modelObject.resize();	// TODO: necessary?
		p.modelObject.portletData.userPortletSize = false;

	}

	

	url = encodeURI( url );
	dojo.xhrGet( {
		url: url,
		handleAs: "text",
		preventCache: true,
		load: function(response) { console&&console.log&&console.log("FreeformPage.personalizeRestore complete"); return response;},
		errror: function(response) { console&&console.log&&console.log("FreeformPage.personalizeRestore complete"); return response;}
	} );
}
// "static" methods
FreeformPage.fetchEvents = function(portletList, data) 
{
	//Let's find the last dropped window, it will have the highest z-index
	var l = portletList.length;
	var highestPortlet = l > 0 ? portletList[0] : null;
	var i;

	for( i = 1; i < l; i++ ) {
		var tempZ = portletList[i].style.zIndex; 
		if (tempZ >= highestPortlet.style.zIndex){
		   highestPortlet = portletList[i];	
		}
	}
       
    //Now get the id from the div and make server call to get events
	if(highestPortlet != null) {
	   var oid = highestPortlet.id;
       var parmString=data.moduleId+";"+data.portletAppID+";"+data.name+";"+data.id;
       url = contextRoot + '/eventAction.do?action=eventsForSelectedPortlet'+'&selectedPortlet=' + parmString+ '&windowId='+ oid +"&XSS="+top.window.XSS;
       url = encodeURI(url);
       bindObj={
            url :url,
            load : function eventingCallbackFunction(data){
                var eventData = dojo.fromJson(data);
	              if (eventData.items && eventData.items.length > 0) {
	                  piiToPWIMap[oid] = eventData.items[0].pii;
	                  pwiToPiiMap[eventData.items[0].pii] = oid;
	              }
                //createNewEvents(data);
                
                var portletObj = EventBroker.getPortletObjectByPii(oid, IscPages.currentPageId, true);
                if (portletObj && portletObj.portletData && portletObj.portletData.iwidget == "false") {
	                  createNewEvents(data);
	              } else {
	                  if (eventData.basePii) {
	                      piiToPWIMap[oid] = eventData.basePii;
	                      pwiToPiiMap[eventData.basePii] = oid;
	                  }
	                  
	                  var iwId = iWidgetUtils.piiToWidgetId(oid);
                    var pageId = IscPages.currentPageId;
                    
                    var iWidgetContainer = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
			              var widget = iWidgetContainer.getWidgetById(iwId);
                    if (widget == null) {
			                  widget = iWBridge.findIframedWidget();
			              }
			              
			              if (widget && (widget.loaded == true)) {
			                  iWidgetUtils.updateSystemWires(pageId);
			              } else {
	                      var eventService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);
	                      eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + iwId, null, function(){
	                          iWidgetUtils.updateSystemWires(pageId);
	                      }, null, null);
	                  }
	              }
            },
            mimetype: "text/html"
            };
       dojo.xhrGet(bindObj);
	}
};
