/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["com.ibm.isclite.dijit.dashboard.portlet"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.isclite.dijit.dashboard.portlet"] = true;
dojo.provide("com.ibm.isclite.dijit.dashboard.portlet");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.cache");
//dojo.require("dojox.layout.ResizeHandle");
dojo.require("com.ibm.isclite.dijit.ResizeHandle");
dojo.require("dojo.dnd.Moveable");
dojo.require("dojo.dnd.move");
dojo.require("dijit.Toolbar");
dojo.require("dojo.fx");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.isclite.dijit.dashboard", "resources", null, "ROOT,ar,cs,da,de,en,es,fi,fr,he,hr,hu,it,ja,ko,nb,nl,pl,pt-br,ru,sl,sv,tr,zh-cn,zh-tw");

// Creating a portlet in markup:
//
// <div id="p1" dojoType="com.ibm.isclite.dijit.dashboard.portlet" portletTitle="I have plain old vanilla
// html content" onResize=szFunc>
// <div name="tip-portlet-toolbar-buttons">
// <div dojoType="dijit.form.DropDownButton" showLabel="false" type="button"
// iconClass="tip-portlet-drop-button" class="tip-portlet-toolbar-button">
// <span>Edit</span>
// <div dojoType="com.ibm.isclite.dijit.dashboard.portlet.dropDownMenu"></div>
// </div>
// <div dojoType="dijit.form.Button" showLabel="false" type="button"
// iconClass="tip-portlet-help-button" class="tip-portlet-toolbar-button">Help</div>
// </div>
//		
// <div style="background-color: transparent;border:1px solid #ccc;">
// Lorem ipsum dolor sit amet, consectetur adipiscing elit.
// </div>
// </div>
//
// The content of the portlet's DIV is used as follows:
// If you want buttons in the titlebar, put them within a <div
// name="tip-portlet-toolbar-buttons"> as a child of the portlet's div
// Anything else in the portlet's div is taken as the portlet's content
//
// Attributes you can set on the portlet
// portletTitle: the string displayed in the portlet's title bar
// expandoDelay: msecs. the mouse has to hover over the title before you get the
// tooltip
// expandoDuration: msecs. the title tooltip is displayed.
//
dojo.declare("com.ibm.isclite.dijit.dashboard.portlet", [ dijit._Widget, dijit._Templated ],
{
	templateString: dojo.cache("com.ibm.isclite.dijit.dashboard", "templates/portlet.html", "<div class=\"tip-portlet ${skin}\" role=\"region\" aria-labelledby=\"${id}_title\" tabindex=\"0\"\n \t    dojoAttachEvent=\"onkeypress:_handleKeys,onclick:_handleClick,onfocus:_handleFocus,onblur:_handleBlur\"\n>\n\t<div dojoAttachPoint=\"shim\"></div>\n\t<div class=\"tip-portlet-frame\"  dojoAttachPoint=\"portletDiv\" >\n\t\t<div class=\"tip-portlet-inner\" dojoAttachPoint=\"innerDiv\">\n\t\t\t<div class=\"tip-portlet-titlebar\" dojoAttachPoint=\"titleBar\">\n\t\t\t\t<div class=\"tip-portlet-titletext\" dojoAttachPoint=\"titleText\" dojoAttachEvent=\"onmouseover:_mouseOverTitle,onmouseout:_mouseOutTitle\">\n\t\t\t\t\t<h1 id=\"${id}_title\" >${portletTitle}</h1>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"tip-portlet-toolbar\" dojoAttachPoint=\"toolbar\" dojoType=\"dijit.Toolbar\" tabindex=\"0\"></div>\n\t\t\t</div>\n\t\t\t<div class=\"content\" dojoAttachPoint=\"containerNode\"></div>\n\t\t\t<div dojoType=\"dijit.form.Button\" class=\"tip-portlet-skin-button\" dojoAttachPoint=\"_skinButton\" dojoAttachEvent=\"onClick:_onSkinButtonClick\" >${skinMe}</div>\n\t\t</div>\n\t\t<div dojoType=\"com.ibm.isclite.dijit.ResizeHandle\" targetId=\"${id}\" dojoAttachPoint=\"resizeHandle\" dojoAttachEvent=\"onResize:_onResize\" animateMethod=\"combine\"></div>\n\t\t<div class=\"tip-portlet-titletext titletext-expando\" dojoAttachPoint=\"titleExpando\" dojoAttachEvent=\"onmouseout:_mouseOutTitle\"><h1 >${portletTitle}</h1></div>\n\t</div>\n</div>\t\n"),
	widgetsInTemplate: true,

	skin: "",				// this portlet's skin
	fullscreen: false,		// is this portlet in fullscreen mode
	//editMode: "view",		// portlet mode (view | edit | dynamic)
	portletTitle: "", 		// displayed title of this portlet
	expandoDelay: 700, 		// delay between mouse over and display of title text popup
	expandoDuration: 3000, 	// how long the title text popup is displayed
	portletData: null,		// from parsed portletDataObject JSON
	eventSettings: null,	// from parsed eventSettings JSON
	
	_mov: null,
	_isMoveable: false,		// can we be moved and resized?
	_isMoving: false,
	_expandoTimer: 0,
	_zIndex: "auto",
	_iframeContent: null,
	_shimSrc: dojo.moduleUrl("com.ibm.isclite.dijit.dashboard") + "templates/shim.html",
	_bkgimg: "",
	skinMe: "Show Menu",

	constructor: function() {
		console && console.log && console.log("com.ibm.isclite.dijit.dashboard.portlet.ctor");
		this.skinMe = dojo.i18n.getLocalization("com.ibm.isclite.dijit.dashboard", "resources").SKIN_ME;
			},
	postMixInProperties: function() {
		this.inherited(arguments);
		var str = this.srcNodeRef.getAttribute("portletDataObject");
		if(str)
			this.portletData = dojo.fromJson(str);
		str = this.srcNodeRef.getAttribute("eventSettings");
		if(str)
			this.eventSettings = dojo.fromJson(str);
	},
	buildRendering: function() {
		console && console.log && console.log("com.ibm.isclite.dijit.dashboard.portlet.buildRendering");
		this.inherited(arguments);
		console.log("build rendering after inherited");

		this._zIndex = dojo.style(this.domNode, "zIndex");
		console.log("after setting zindex");
		if (isNaN(this._zIndex)) {
		console.log("inside if");
			this._zIndex = 1;
			dojo.style(this.domNode, "zIndex", 1);
			console.log("after setting style zindex");
		}
		console.log("before setting backgroundimage");
		this._bkgimg = dojo.style(this.portletDiv, "backgroundImage");
	},
	postCreate: function() {
	console.log("in post create");
		this.inherited(arguments);
		if(this.shim){
		console.log("in post create after this.shim");
		if(this._isTransparent()){
			this.shim.style.display = "none";
			console.log("in post create - set display to none");
		}else{
			console.log("its not trasssnsparent");
			this.shim.style.display = "";
			console.log("in post create setting display to empty");
		}
		}
		console.log("in post create before place content");
		this._placeContent(this.skin);
		console.log("in post create after place content");
		
	},
	startup: function() {
		if(this._started) return;
		this.inherited(arguments);

		// move the buttons to the toolbar
		var widget_list, i, btns_node = dojo.query(
				"[name='tip-portlet-toolbar-buttons']",
				this.containerNode);
		if (btns_node.length) {
			widget_list = dijit.findWidgets(btns_node[0]);
			for (i = 0; i < widget_list.length; ++i) {
				this.toolbar.addChild(widget_list[i]);
			}
			;
			btns_node[0].parentNode.removeChild(btns_node[0]);
		}

		// constrain the width of the portlet so the buttons and 1 character of the title are always visible
		// constrain the height of the portlet so the titlebar
		// is always visible
		var mb = dojo.marginBox(this.toolbar.domNode);
		dojo.style(this.titleText, this.isLeftToRight() ? "marginRight" : "marginLeft", mb.w + "px");
		var minw = mb.w
				+ parseInt(dojo.style(this.innerDiv, "right"))
				+ parseInt(dojo.style(this.innerDiv, "left"))
				+ parseInt(dojo.style(this.titleText, "fontSize")), 
			minh = parseInt(dojo.style(this.innerDiv, "top"))
				+ parseInt(dojo.style(this.containerNode, "top"));
		
		this.resizeHandle.minSize = {
			w: minw,
			h: minh
		};
		this.connect(this.resizeHandle.domNode, "onmousedown", "_beginSizing");

		var iframelist = dojo.query("iframe", this.containerNode);
		if (iframelist.length) {
			this._iframeContent = iframelist[0];
			dojo.style(this.containerNode, "overflow", "hidden");
			dojo.isIE && this._sizeIframeContent();
		}

		this._doSetMoveable(this._isMoveable);
		
		this.onstartup();
	},
	onstartup: function()
	{
		// a hook for a <script> block in the portlet declaration
	},
	destroy: function() {
		console && console.log && console.log("com.ibm.isclite.dijit.dashboard.portlet.destroy " + this.id);
		this.portletData = this.eventSettings = null;
		this._mov && this._mov.destroy();
		this.titleExpando.parentNode.removeChild(this.titleExpando);
		this.titleExpando = null;
		this.shim.parentNode && this.shim.parentNode.removeChild(this.shim);
		this.shim = null;
		this.inherited(arguments);
	},
	addShim: function()
	{
		if("IFRAME" != this.shim.tagName) {
			var placeholder = this.shim;
			this.shim = dojo.create("iframe", {className:"tip-portlet-shim", src: this._shimSrc, role:"presentation", tabindex:"-1"});
			placeholder.parentNode.replaceChild(this.shim, placeholder);
			dojo.style(this.shim, {display: this._isTransparent() ? "none": ""});
			window.setTimeout(dojo.hitch(this, function() {
				if(this.shim) {				
				var bgcolor = dojo.style(document.body, "backgroundColor");				
				this.shim.contentDocument.body.style.backgroundColor = bgcolor; 						
				}
			}), 250);				
		}
	},
	_placeContent: function(skin)
	{
		if("skinA" == skin || "skinC" == skin) {
			dojo.style(this.containerNode, "top", 0);
		}
		else {
				dojo.style(this.containerNode, "top", this.titleBar.scrollHeight + "px");
		}
	},
	// get the space available to the portlet's content
	_getSizeAttr: function() {
		var b = dojo.contentBox(this.containerNode);
		return {
			w: b.w,
			h: b.h
		};
	},
	// get the location and size of this portlet.
	_getPositionAttr: function() {
		var mb = dojo.marginBox(this.domNode);
		mb.z = dojo.style(this.domNode, "zIndex");
		return mb;
	},
	_getContentSizeAttr: function() {
		var n = this.containerNode;
		var sz = dojo.marginBox(n);
		var w = dojo.style(n, "marginLeft") + dojo.style(n, "marginRight");
		w += dojo.style(n, "borderLeftWidth") + dojo.style(n, "borderRightWidth");
		w += dojo.style(n, "paddingLeft") + dojo.style(n, "paddingRight");
		
		var h = dojo.style(n, "marginTop") + dojo.style(n, "marginBottom");
		h += dojo.style(n, "borderTopWidth") + dojo.style(n, "borderBottomWidth");
		h += dojo.style(n, "paddingTop") + dojo.style(n, "paddingBottom");
		
		sz.w -= w;
		sz.h -= h;

		return sz;
	},
	_setPortletTitleAttr: function(new_title) {
		this.portTitle = new_title;
		var t = dojo.byId(this.id + "_title");
		if(t) t.innerHTML = new_title;
	},
	
	// internals
	_mouseOverTitle: function(event) {
		//console.log("com.ibm.isclite.dijit.dashboard.portlet._mouseOverTitle");
		if (!this._expandoTimer
				&& dojo.contentBox(this.titleText).w < dojo.contentBox(this.titleExpando).w) {
			this._expandoTimer = window.setTimeout(dojo.hitch(this, this._showTitleExpando), this.expandoDelay);
		}
	},
	_showTitleExpando: function() {
		if (this._isMoving)
			return;
		if (this.titleExpando.parentNode === this.portletDiv) {
			this.portletDiv.removeChild(this.titleExpando);
			dojo.body().appendChild(this.titleExpando);
			this.connect(this.titleExpando, "onclick", "_hideTitleExpando");
		}
		var offsetX = 0, offsetY = 0, node = this.titleText;
		while (node.offsetParent) {
			offsetX += node.offsetLeft;
			offsetY += node.offsetTop;
			node = node.offsetParent;
		}
		if(!this.isLeftToRight()) {
			offsetX -= (this.titleText.scrollWidth - this.titleText.offsetWidth);
		}
		dojo.style(this.titleExpando, {
			left: (offsetX - 3) + "px",
			top: (offsetY - 3) + "px",
			padding: "3px",
			visibility: "visible"
		});
		window.setTimeout(dojo.hitch(this, this._hideTitleExpando), this.expandoDuration);
	},
	_hideTitleExpando: function() {
		this._expandoTimer = 0;
		dojo.style(this.titleExpando, "visibility", "hidden");
	},
	_mouseOutTitle: function(event) {
		//console.log("com.ibm.isclite.dijit.dashboard.portlet._mouseOutTitle");
		window.clearTimeout(this._expandoTimer);
		this._expandoTimer = 0;
	},
	_startMove: function() {
		if (this._isMoving)
			return;
		this._isMoving = true;
		this._zIndex = dojo.style(this.domNode, "zIndex");
		dojo.style(this.domNode, "zIndex", 1000);

		if (this._iframeContent && (dojo.isFF || dojo.isWebKit))
			dojo.style(this._iframeContent, "visibility", "hidden");
	},
	_stopMove: function() {
		dojo.style(this.domNode, "zIndex", this._zIndex);
		this._isMoving = false;
		if (this._iframeContent && (dojo.isFF || dojo.isWebKit))
			dojo.style(this._iframeContent, "visibility", "visible");
		this.onMove();
	},
	_beginSizing: function() {
		// ie has trouble resizing the portlet smaller when the iframe is displayed
		if (dojo.isIE && this._iframeContent)
			dojo.style(this._iframeContent, "visibility", "hidden");
	},
	_onResize: function(event) {
		if (dojo.isIE && this._iframeContent)
			dojo.style(this._iframeContent, "visibility", "visible");
		window.setTimeout(dojo.hitch(this, function() {
			dojo.isIE && this._iframeContent && this._sizeIframeContent();
			this.onResize(this);
			iscPortlet.sendResizeEvent("com.ibm.isclite.dijit.dashboard.portlet.onResize");
		}), this.resizeHandle.animateDuration * 2);
	},
	_sizeIframeContent: function() {
		var cb = dojo.contentBox(this.containerNode);
		dojo.style(this._iframeContent, {
			width: cb.w + "px",
			height: cb.h + "px"
		});
	},
	onResize: function(portlet) {
		// a stub for clients to connect to
		console && console.log && console.log("com.ibm.isclite.dijit.dashboard.portlet.onResize");
	},
	onMove: function(portlet) {
		// a stub for clients to connect to
		console && console.log && console.log("com.ibm.isclite.dijit.dashboard.portlet.onMove");
	},
	
	_getMoveableAttr: function()
	{
		return this._isMoveable;
	},
	_setMoveableAttr: function(bMoveable)
	{
		if(bMoveable == this._isMoveable) return;
		this._isMoveable = bMoveable;
		this._doSetMoveable(bMoveable);
	},
	_moveEventHandles: [],
	_doSetMoveable: function(bMoveable)
	{
		if(bMoveable) {
			if(!this._mov) {
				// I can move and resize, but not setup yet
				this._mov = new dojo.dnd.move.boxConstrainedMoveable(this.domNode, 
						{
					handle: this.titleText,
					box: {t:0, l:0, w:Number.MAX_VALUE, h:Number.MAX_VALUE},
					within: true
						});

				if(!this.fullscreen) {
					this._moveEventHandles.push(this.connect(this._mov, "onMoveStart", this._startMove));
					this._moveEventHandles.push(this.connect(this._mov, "onMoveStop", this._stopMove));
				}
				this._moveEventHandles.push(this.connect(this.domNode, "onmouseover", "_skinOver"));
				this._moveEventHandles.push(this.connect(this.domNode, "onmouseout", "_skinOut"));
			}
			dojo.removeClass(this.domNode, "tip-portlet-immobile");
		}
		else {
			// I cannot move or resize
			if(this._mov) {
				var h;
				while(h = this._moveEventHandles.pop()) {
					this.disconnect(h);
				}
				this._mov.destroy();
				this._mov = null;
			}
			dojo.addClass(this.domNode, "tip-portlet-immobile");
		}
	},	
	// fullscreen
	_getFullscreenAttr: function()
	{
		return this.fullscreen; //dojo.hasClass(this.domNode, "isc-portlet-fullscreen");
	},
	_setFullscreenAttr: function(isFullscreen)
	{
		if(this.domNode) {
			if(isFullscreen) {
				dojo.addClass(this.domNode, "isc-portlet-fullscreen");
				dojo.style(this.domNode, {top: "0px", left: "0px", width:"100%", height:"100%"});
			}
			else {
				var sz = this.portletData.unsavedPortletSize;
				if (sz == null) {
					sz = this.portletData.userPortletSize ? this.portletData.userPortletSize : this.portletData.globalPortletSize;
				}
				dojo.removeClass(this.domNode, "isc-portlet-fullscreen");
				dojo.marginBox(this.domNode, {l: sz[2], t: sz[3], w: sz[0], h: sz[1]});
			}
		}
		this.fullscreen  = isFullscreen;
	},
	toggleFullscreen: function() {
		this._setFullscreenAttr(!this.fullscreen);
	},
	// skinning
	_getSkinAttr: function()
	{
		return this.skin;
	},
	_setSkinAttr: function(skin)
	{
		if(skin == this.skin) return;
		this.skin = skin;
		if(this.domNode) {
			dojo.toggleClass(this.domNode, "skinA", "skinA" == skin);
			dojo.toggleClass(this.domNode, "skinB", "skinB" == skin);
			dojo.toggleClass(this.domNode, "skinC", "skinC" == skin);

			// kill the animations
			this._isin = false;
			if(this._skinOverAnim) {
				this._skinOverAnim.stop();
				this._skinOverAnim.destroy && this._skinOverAnim.destroy();
			}
			if(this._skinOutAnim) {
				this._skinOutAnim.stop(true);
				this._skinOutAnim.destroy && this._skinOutAnim.destroy();
			}
			this._skinOverAnim = this._skinOutAnim = null;
			
			// remove inline styles put there by the animations
			this.titleBar.removeAttribute("style");
			this.containerNode.removeAttribute("style");
			this.portletDiv.removeAttribute("style");
			this.innerDiv.removeAttribute("style");
			this.resizeHandle.domNode.removeAttribute("style");
			
			// deal with the shim
			if("IFRAME" === this.shim.tagName)
				dojo.style(this.shim, {display: this._isTransparent() ? "none": ""});
			
			this._placeContent(this.skin);
		}
	},
	_isTitleless: function()
	{
		return "skinA" == this.skin || "skinC" == this.skin;
	},
	_isTransparent: function()
	{
		return "skinB" == this.skin || "skinC" == this.skin;
	},
	_within: function(event) 
	{
		var p = dojo.position(this.domNode);
		return event.pageX > p.x && event.pageX < (p.x + p.w)  
			&& event.pageY > p.y && event.pageY < (p.y + p.h);
	},
	_skinOverTimer: 0,
	_skinOutTimer: 0,
	_skinOverDelay: 750,
	_isin: false,
	_skinOver: function(event)
	{
		if(this._isin) return;
		if(!this._isTransparent() && !this._isTitleless()) return;
		this._isin = true;
		if(this._skinOverTimer) {
			window.clearTimeout(this._skinOverTimer);
			this._skinOverTimer = 0;
		}
		if(this._skinOutTimer) {
			window.clearTimeout(this._skinOutTimer);
			this._skinOutTimer = 0;
		}
		if(this._reskinned) return;
		this._skinOverTimer = window.setTimeout(dojo.hitch(this, function() 
		{
			console && console.log && console.log("com.ibm.isclite.dijit.dashboard.portlet._skinOver timer func");
			this._skinOverTimer = 0;
			dojo.addClass(this.domNode, "over");
		}), this._skinOverDelay);
	},
	_skinOut: function(event)
	{
		if(!this._isin) return;
		if(this._within(event)) return;
		this._isin = false;
		if(this._skinOverTimer) {
			window.clearTimeout(this._skinOverTimer);
			this._skinOverTimer = 0;
			return;
		}
		if(this._skinOutTimer) {
			window.clearTimeout(this._skinOutTimer);
			this._skinOutTimer = 0;
		}
		this._skinOutTimer = window.setTimeout(dojo.hitch(this, function() {
			console && console.log && console.log("com.ibm.isclite.dijit.dashboard.portlet._skinOut timer func");
			dojo.removeClass(this.domNode, "over");
			
			if(this._skinOverAnim) this._skinOverAnim.stop(true);
			if(this._reskinned) {
				var a = this._getSkinOutAnimator();
				if(a) a.play();
				this._reskinned = false;
			}
		}), this._skinOverDelay);	
	},
	_reskinned: false,
	_onSkinButtonClick: function()
	{
		this._reskinned = true;
		if(this._skinOutAnim) this._skinOutAnim.stop(true);
		var a = this._getSkinOverAnimator();
		if(a) a.play();
		dojo.removeClass(this.domNode, "over");
	},
	_skinAnimationDuration: 500,
	_titleShow: null,
	_titleHide: null,
	_transOn: null,
	_transOff: null,
	_skinOverAnim: null,	// animation that plays onmouseover
	_skinOutAnim: null,		// animation that plays onmouseout
	_getSkinOverAnimator: function()
	{
		this._makeAnimators();
		return this._skinOverAnim;
	},
	_getSkinOutAnimator: function()
	{
		this._makeAnimators();
		return this._skinOutAnim;
	},
	
	_makeAnimators: function()
	{
		if(null == this._skinOverAnim) {
			if("skinA" == this.skin) {
				this._makeTitleAnimators();
				this._skinOverAnim = this._titleShow;
				this._skinOutAnim = this._titleHide;
			}
			else if("skinB" == this.skin) {
				this._makeTransparencyAnimators();
				this._skinOverAnim = this._transOff;
				this._skinOutAnim = this._transOn;
			}
			else if("skinC" == this.skin) {
				this._makeTitleAnimators();
				this._makeTransparencyAnimators();
				this._skinOverAnim = dojo.fx.combine([this._titleShow, this._transOff]);
				this._skinOutAnim = dojo.fx.combine([this._titleHide, this._transOn]);
			}
			
			if(this._skinOverAnim) {
				this.connect(this._skinOverAnim, "onBegin", function() {
					if(this.containerNode.scrollHeight == this.containerNode.clientHeight) {
						// there is currently no vertical scroll bar. prevent one from showing up during the animation
						dojo.style(this.containerNode, "overflow", "hidden");
					}
					dojo.removeClass(this.domNode, this.skin);
				});
				this.connect(this._skinOverAnim, "onEnd", function() {
					this.onResize();
					dojo.style(this.containerNode, "overflow", ""); 
				});
				this.connect(this._skinOutAnim, "onEnd", function() {
					dojo.addClass(this.domNode, this.skin);
					this.onResize();
				});
			}
		}
	},
	_makeTitleAnimators: function()
	{
		if(this._titleShow) return;
	
		var wipein = new dojo.fx.wipeIn({
			node: this.titleBar,
			duration: this._skinAnimationDuration
		});
		var slidein = new dojo.fx.slideTo({
			node: this.containerNode,
			duration: this._skinAnimationDuration,
			top: this.titleBar.scrollHeight,
			left: 0,
			units: "px"
		});
		this._titleShow = dojo.fx.combine([wipein, slidein]);
		
		var wipeout = new dojo.fx.wipeOut({
			node: this.titleBar,
			duration: this._skinAnimationDuration
		});
		var slideout = new dojo.fx.slideTo({
			node: this.containerNode,
			duration: this._skinAnimationDuration,
			top: 0,
			left: 0,
			units: "px"
		});
		this._titleHide = dojo.fx.combine([wipeout, slideout]);
	},	
	_makeTransparencyAnimators: function()
	{
		if(this._transOn) return;
		
		var portletMetrics = this._getPortletMetrics();
		var io = portletMetrics.innerOffset;
		
		this._transOff = dojo.animateProperty({
			node: this.innerDiv,
			duration: this._skinAnimationDuration,
			properties: {
				top: io.t,
				right: io.r,
				bottom: io.b,
				left: io.l
			},
			onBegin: dojo.hitch(this, this._transparencyOff2),
			onEnd: dojo.hitch(this, function(){this.innerDiv.removeAttribute("style");})
		});
		this._transOn = dojo.animateProperty({
			node: this.innerDiv,
			duration: this._skinAnimationDuration,
			properties: {
				top: 0,
				right: 0,
				bottom: 0,
				left: 0
			},
			onEnd: dojo.hitch(this, this._transparencyOn2)
		});
	},
	_transparencyOff2: function()
	{
		dojo.style(this.titleText, "marginRight", dojo.marginBox(this.toolbar.domNode).w + "px");	// make room for the toolbar 
		dojo.style(this.toolbar.domNode, "display", "block");	// the toolbar is redisplayed 
		if(dojo.isIE) {
			dojo.style(this.portletDiv, {
				backgroundImage: "none",
				 filter: "alpha(opacity = 50)",
				 backgroundColor: "rgb(232, 238, 245)"
			});
		}
		else {
			dojo.style(this.portletDiv, {
				backgroundImage: "none",
				backgroundColor: "rgba(232, 238, 245, .5)" //"#E8EEF5",
			});
		}		
	},
	_transparencyOn2: function()
	{
		dojo.style(this.toolbar.domNode, "display", "");		
		dojo.style(this.titleText, "marginRight", "");
		dojo.style(this.portletDiv, "backgroundImage", "");
		if("IFRAME" === this.shim.tagName)
			dojo.style(this.shim, "display", "none");
		dojo.style(this.portletDiv, {
			backgroundColor: "",
			backgroundImage: "",
			backgroundRepeat: "",
			backgroundAttachment: "",
			backgroundPosition: "",
			filter: ""
		});
	},
	// keyboard navigatoin
	_handleKeys: function(event) 
	{
		//console && console.log && console.log("_handleKeys: ", event.keyCode, ": ", event.target);
		if(event.target !== this.domNode)
			return;
		if(!this._isMoveable)
			return;
		
		var delta, bResize, mb;
		var kc = event.keyCode, dk = dojo.keys;
		
		if(kc == dk.LEFT_ARROW || kc == dk.RIGHT_ARROW || kc == dk.UP_ARROW || kc == dk.DOWN_ARROW) {
			
			if(/tip-mode-view|tip-portlet-immobile|isc-portlet-fullscreen/.test(this.domNode.className)) {
				return;
			}
			
			delta = event.ctrlKey ? 1 : 10;
			bResize = event.shiftKey;
			mb = dojo.marginBox(this.domNode);		
		
			switch(kc) {
			case dk.LEFT_ARROW:
				if(bResize) 
					mb.w -= delta;
				else 
					mb.l -=  delta;
				break;
			case dk.RIGHT_ARROW:
				if(bResize)
					mb.w += delta;
				else
					mb.l += delta;
				break;
			case dk.UP_ARROW:
				if(bResize) 
					mb.h -= delta;
				else
					mb.t -= delta;
				break;
			case dk.DOWN_ARROW:
				if(bResize) 
					mb.h += delta;
				else
					mb.t += delta;
				break;
			}
			
			dojo.marginBox(this.domNode, mb);
			this._queueEvent(bResize ? this.onResize : this.onMove);
			dojo.stopEvent(event);
		}

		return;
	},
	// so we don't fire onMove and onResize events every time the user presses
	// a key, fire them on a timer.
	// theEvent is the event/method to call. Either this.onMode or this.onResize
	_queuedEvent: {func: null, timer: -1},
	_queueEvent: function(theEvent) 
	{
		function fireQueuedAndClear()
		{
			//console.log("com.ibm.isclite.dijit.dashboard.portlet.fireQueuedAndClear");
			this._queuedEvent.func(this);
			window.clearTimeout(this._queuedEvent.timer);
			this._queuedEvent.func = null;
			this._queuedEvent.timer = -1;
		}
		
		if(null == this._queuedEvent.func) {
			//console.log("com.ibm.isclite.dijit.dashboard.portlet._queueEvent: new event");
			// no queued event, queue the new event
			this._queuedEvent.func = theEvent;
			this._queuedEvent.timer = window.setTimeout(dojo.hitch(this, fireQueuedAndClear), 700);
		}
		else {
			// new event is same as the queued event, requeue
			if(theEvent == this._queuedEvent.func) {
				//console.log("com.ibm.isclite.dijit.dashboard.portlet._queueEvent: requeue same event");
				window.clearTimeout(this._queuedEvent.timer);
				this._queuedEvent.timer = window.setTimeout(dojo.hitch(this, fireQueuedAndClear), 700);
			}
			else {
				// new event is different from queued event. Fire it, then queue the new one
				//console.log("com.ibm.isclite.dijit.dashboard.portlet._queueEvent: fire old and queue new event");
				fireQueuedAndClear.call(this);
				this._queuedEvent.func = theEvent;
				this._queuedEvent.timer = window.setTimeout(dojo.hitch(this, fireQueuedAndClear), 700);				
			}
		}
	},
	_handleClick: function(event)
	{
		console && console.log && console.log("_handleClick: ", event.target);
		var node;
		for(node = event.target; node != this.domNode; node = node.parentNode) {
			if(node == this.toolbar.domNode) {
				break;
			}
			if(node == this.titleBar) {
				this.domNode.focus();
				dojo.stopEvent(event);
				break;
			}
		}
		return;
	},
	_handleFocus: function(event)
	{
		console && console.log && console.log("_handleFocus: ", event.target);
		return;
	},
	_handleBlur: function(event)
	{
		console && console.log && console.log("_handleBlur: ", event.target);
		return;
	},
	_getPortletMetrics: function()
	{
		console && console.log && console.log("portlet._getPortletMetrics");
		var portletMetrics;
		try {
			var d = document.createElement("div");
			d.className = "tip-portlet-inner";
			this.domNode.appendChild(d);
			var portletMetrics = {
				innerOffset: {
					t: parseInt(dojo.style(d, "top")),
					r: parseInt(dojo.style(d, "right")),
					b: parseInt(dojo.style(d, "bottom")),
					l: parseInt(dojo.style(d, "left"))
				}
			};
			this.domNode.removeChild(d);
		}
		catch(ex) {
			console.error("Error getting portlet metrics.", ex);
			portletMetrics = {innerOffset: {t:0, r:10, b:10, l:10}};	// reasonable defaults
		}
		console && console.log && console.log("--- innerOffset:", portletMetrics);
		return portletMetrics;
	}

});

}
